install 23 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (seleción express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (seleción avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (seleción del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 200)
  54. error="$type $codeNum:\tError interno (seleción de base de datos).\n"
  55. ;;
  56. 201)
  57. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 202)
  60. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  61. ;;
  62. 203)
  63. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  64. ;;
  65. 204)
  66. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  67. ;;
  68. 205)
  69. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  70. ;;
  71. 206)
  72. type="WARNING"
  73. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  74. ;;
  75. 207)
  76. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  77. ;;
  78. 208)
  79. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  80. ;;
  81. 209)
  82. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  83. ;;
  84. 210)
  85. type="WARNING"
  86. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  87. ;;
  88. 211)
  89. type="WARNING"
  90. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  91. ;;
  92. 212)
  93. error="$type $codeNum:\tImposible recargar base de datos.\n"
  94. ;;
  95. 800)
  96. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  97. ;;
  98. 801)
  99. error="$type $codeNum:\t'whiptail' no instalado.\n"
  100. ;;
  101. 802)
  102. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  103. ;;
  104. 803)
  105. error="$type $codeNum:\t'apt-get' no instalado.\n"
  106. ;;
  107. 804)
  108. error="$type $codeNum:\t'yum' no instalado.\n"
  109. ;;
  110. 805)
  111. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  112. ;;
  113. 806)
  114. error="$type $codeNum:\t'ufw' no instalado.\n"
  115. ;;
  116. 807)
  117. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  118. ;;
  119. 808)
  120. error="$type $codeNum:\t'tput' no instalado.\n"
  121. ;;
  122. 900)
  123. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  124. ;;
  125. 901)
  126. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  127. ;;
  128. 902)
  129. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  130. ;;
  131. *)
  132. error="ERROR 13:\tError interno (comprobación de errores)\n"
  133. exitNum=1
  134. codeNum=13
  135. ;;
  136. esac
  137. if [ $exitNum -ne 0 ];then
  138. printf "$error"
  139. if [ $type = "ERROR" ];then
  140. exit $codeNum
  141. fi
  142. fi
  143. unset error exitNum codeNum type
  144. }
  145. OSInfo() {
  146. #printf "Detectando SO..."
  147. OS=$(uname -s)
  148. if [ $OS = "Linux" ]; then
  149. OS="GNU/Linux"
  150. if [ -f /etc/os-release ]; then
  151. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  152. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  153. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  154. for i in $ID_LIKE; do
  155. #printf "$i\n"
  156. case $i in
  157. debian|ubuntu)
  158. debianOS=true
  159. break
  160. ;;
  161. rhel|fedora)
  162. rhelOS=true
  163. break
  164. ;;
  165. *)
  166. debianOS=false
  167. rhelOS=false
  168. ;;
  169. esac
  170. done
  171. elif [ -f /etc/debian-version ]; then
  172. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  173. DIST="Debian"
  174. REV=""
  175. ID_LIKE="debian"
  176. debianOS=true
  177. elif [ -f /etc/redhat-release ]; then
  178. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  179. DIST="Red-Hat"
  180. REV=""
  181. ID_LIKE="rhel"
  182. rhelOS=true
  183. else
  184. # Other Linux (No Soportado)
  185. DIST=""
  186. REV=""
  187. ID_LIKE=""
  188. fi
  189. else
  190. # UNIX, OS X, ... (No Soportado)
  191. DIST=$OS
  192. REV=""
  193. fi
  194. #printf " $OS $DIST $REV\n"
  195. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  196. }
  197. comprobarRoot() {
  198. comprobarError $(id -u) 800
  199. }
  200. comprobarDependencias() {
  201. # Comprobamos whiptail
  202. which whiptail > /dev/null 2>&1
  203. comprobarError $? 801
  204. # Comprobamos hostnamectl
  205. which hostnamectl > /dev/null 2>&1
  206. comprobarError $? 802
  207. # Comprobamos tput
  208. which tput > /dev/null 2>&1
  209. comprobarError $? 808
  210. if [ $debianOS = true ];then
  211. # Comprobamos apt-get
  212. which apt-get > /dev/null 2>&1
  213. comprobarError $? 803
  214. # Actualizamos base de datos del repositorio
  215. printf "Actualizando repositorio APT..."
  216. result=$(apt-get -q -y update)
  217. comprobarError $? 805 $result
  218. printf " OK.\n"
  219. # Comprobamos Firewall (ufw)
  220. which ufw > /dev/null 2>&1
  221. comprobarError $? 806
  222. fi
  223. if [ $rhelOS = true ]; then
  224. # Comprobamos yum
  225. which yum > /dev/null 2>&1
  226. comprobarError $? 804
  227. # Actualizamos base de datos del repositorio
  228. printf "Actualizando repositorio YUM..."
  229. result=$(yum -y makecache 2>&1)
  230. comprobarError $? 805 $result
  231. printf " OK.\n"
  232. # Comprobamos Firewall (firewall-cmd)
  233. which firewall-cmd > /dev/null 2>&1
  234. comprobarError $? 807
  235. fi
  236. }
  237. inicializarVariables() {
  238. debianOS=false
  239. rhelOS=false
  240. apacheOn=false
  241. nginxOn=false
  242. mySQLOn=false
  243. mariaDBOn=false
  244. phpOn=false
  245. mediaWikiOn=false
  246. moodleOn=false
  247. actualizacionesOn=false
  248. progreso=0
  249. progresoTotal=0
  250. }
  251. instalacionExpress() {
  252. apacheOn=true
  253. mariaDBOn=true
  254. phpOn=true
  255. mediaWikiOn=true
  256. moodleOn=true
  257. actualizacionesOn=true
  258. progresoTotal=15
  259. # Preguntas mínimas
  260. establecerFQDN
  261. leerSQLPasswd
  262. }
  263. mostrarBienvenida() {
  264. ANCHO=$(tput cols)
  265. ALTO=$(tput lines)
  266. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  267. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  268. exit 1
  269. fi
  270. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  271. comprobarError $? 1
  272. }
  273. mostrarExpress() {
  274. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  275. "Express" "Instalación rápida" ON \
  276. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  277. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  278. comprobarError $? 1
  279. case $express in
  280. Express)
  281. instalacionExpress
  282. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  283. ;;
  284. Avanzada)
  285. mostrarAvanzada
  286. ;;
  287. *)
  288. comprobarError 1 2
  289. ;;
  290. esac
  291. }
  292. mostrarAvanzada() {
  293. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 7 \
  294. "WebServer" "Instalar servidor web http/https" ON \
  295. "Database" "Instalar una base de datos SQL" ON \
  296. "PHP" "Instala PHP7" ON \
  297. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  298. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  299. "Moodle" "Instalar campus virtual con Moodle" ON \
  300. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  301. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  302. comprobarError $? 1
  303. # Mejora: autodetección de componentes ya instalados
  304. for i in $componentes; do
  305. case $i in
  306. \"WebServer\")
  307. mostrarWebServer
  308. progresoTotal=$((progresoTotal + 2))
  309. ;;
  310. \"Database\")
  311. mostrarDatabase
  312. progresoTotal=$((progresoTotal + 2))
  313. ;;
  314. \"PHP\")
  315. phpOn=true
  316. progresoTotal=$((progresoTotal + 2))
  317. ;;
  318. \"SSL/TLS\")
  319. # 2 Opciones: Let's Encrypt o Autofirmado
  320. progresoTotal=$((progresoTotal + 2))
  321. ;;
  322. \"MediaWiki\")
  323. mediaWikiOn=true
  324. progresoTotal=$((progresoTotal + 2))
  325. ;;
  326. \"Moodle\")
  327. moodleOn=true
  328. progresoTotal=$((progresoTotal + 2))
  329. ;;
  330. \"Actualizaciones\")
  331. actualizacionesOn=true
  332. progresoTotal=$((progresoTotal + 1))
  333. ;;
  334. *)
  335. comprobarError 1 3
  336. ;;
  337. esac
  338. done
  339. progresoTotal=$((progresoTotal + 2))
  340. }
  341. mostrarWebServer() {
  342. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  343. "Apache" "Instalar el servidor web Apache2" ON \
  344. "Nginx" "Instalar el servidor web Nginx" OFF \
  345. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  346. comprobarError $? 1
  347. case $webServer in
  348. Apache)
  349. apacheOn=true
  350. ;;
  351. Nginx)
  352. nginxOn=true
  353. ;;
  354. *)
  355. comprobarError 1 100
  356. ;;
  357. esac
  358. # Otras opciones (FQDN)
  359. establecerFQDN
  360. }
  361. establecerFQDN() {
  362. while [ -z $hostname ]; do
  363. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  364. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  365. hostnamectl set-hostname $hostname
  366. else
  367. hostname=$(hostname)
  368. fi
  369. done
  370. #printf "\nHostname: $hostname\n"
  371. }
  372. instalarApache() {
  373. if [ $debianOS = true ];then
  374. result=$(apt-get -q -y install apache2 2>&1)
  375. comprobarError $? 101 $result
  376. elif [ $rhelOS = true ]; then
  377. result=$(yum -y install httpd 2>&1)
  378. comprobarError $? 101 $result
  379. else
  380. comprobarError 1 104
  381. fi
  382. }
  383. instalarNginx() {
  384. if [ $debianOS = true ];then
  385. result=$(apt-get -q -y install nginx 2>&1)
  386. comprobarError $? 102 $result
  387. elif [ $rhelOS = true ]; then
  388. # Hay que instalar primero otro repositorio
  389. result=$(yum -y install epel-release)
  390. comprobarError $? 103 $result
  391. result=$(yum -y install nginx 2>&1)
  392. comprobarError $? 102 $result
  393. else
  394. comprobarError 1 105
  395. fi
  396. }
  397. mostrarDatabase() {
  398. if [ $debianOS = true ]; then
  399. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  400. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  401. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  402. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  403. comprobarError $? 1
  404. case $database in
  405. MySQL)
  406. mySQLOn=true
  407. ;;
  408. MariaDB)
  409. mariaDBOn=true
  410. ;;
  411. *)
  412. comprobarError 1 200
  413. ;;
  414. esac
  415. elif [ $rhelOS = true ]; then
  416. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  417. comprobarError $? 1
  418. mariaDBOn=true
  419. else
  420. comprobarError 1 200
  421. fi
  422. # Otras opciones (contraseña)
  423. leerSQLPasswd
  424. }
  425. leerSQLPasswd() {
  426. control=false
  427. error=""
  428. # Leemos la contreseña (stdin) y confirmamos
  429. while [ $control = false ]; do
  430. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  431. comprobarError $? 1
  432. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  433. comprobarError $? 1
  434. #printf "SQL Password 1: $sqlPasswd\n"
  435. #printf "SQL Password 2: $sqlPasswd2\n"
  436. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  437. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  438. elif [ $sqlPasswd != $sqlPasswd2 ];then
  439. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  440. else
  441. control=true
  442. fi
  443. done
  444. #printf "SQL Password: $sqlPasswd\n"
  445. unset control error sqlPasswd2
  446. }
  447. establecerSQLPasswd() {
  448. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  449. # Mejora: ¿Si ya tiene una contraseña asignada?
  450. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  451. if [ $? -eq 0 ];then
  452. # Establecemos contraseña del usuario root
  453. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" > /dev/null 2>&1
  454. comprobarError $? 207
  455. # Desactivamos acceso root desde el exterior (solo localhost)
  456. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" > /dev/null 2>&1
  457. comprobarError $? 208
  458. # Eliminamos todos los usuarios anónimos
  459. mysql -e "DELETE FROM mysql.user WHERE User=''" > /dev/null 2>&1
  460. comprobarError $? 209
  461. # Eliminamos bases de datos 'test'
  462. mysql -e "DROP DATABASE IF EXISTS test" > /dev/null 2>&1
  463. comprobarError $? 210
  464. # Eliminamos privilegios de la base de datos 'test'
  465. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" > /dev/null 2>&1
  466. comprobarError $? 211
  467. # Aplicamos los cambios
  468. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  469. comprobarError $? 212
  470. else
  471. comprobarError $? 206
  472. fi
  473. }
  474. instalarMySQL() {
  475. if [ $debianOS = true ];then
  476. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  477. comprobarError $? 201 $result
  478. elif [ $rhelOS = true ]; then
  479. # MySQL no disponible en RHEL. 2 opciones:
  480. # 1) Instalar un repositorio adicional
  481. # 2) No instalar MySQL en distribuciones RHEL
  482. comprobarError 1 205
  483. else
  484. comprobarError 1 203
  485. fi
  486. }
  487. instalarMariaDB() {
  488. if [ $debianOS = true ];then
  489. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  490. comprobarError $? 202 $result
  491. elif [ $rhelOS = true ]; then
  492. result=$(yum -y install mariadb-server mariadb 2>&1)
  493. comprobarError $? 202 $result
  494. else
  495. comprobarError 1 204
  496. fi
  497. }
  498. habilitarServicio() {
  499. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  500. # Intentamos con systemctl (SystemD)
  501. printf "Habilitando servicio $1"
  502. if [ $# -le 0 ];then
  503. comprobarError 1 900
  504. fi
  505. which systemctl > /dev/null 2>&1
  506. if [ $? -eq 0 ]; then
  507. printf " (SystemD)..."
  508. systemctl start $1 > /dev/null 2>&1
  509. comprobarError $? 901 $1
  510. systemctl enable $1 > /dev/null 2>&1
  511. comprobarError $? 902 $1
  512. else
  513. # Intentamos con service (Upstart)
  514. which service > /dev/null 2>&1
  515. if [ $? -eq 0 ]; then
  516. printf " (Upstart)..."
  517. service $1 start > /dev/null 2>&1
  518. comprobarError $? 901 $1
  519. else
  520. # Intentamos con init.d (SystemV)
  521. printf " (SystemV)..."
  522. /etc/init.d/$1 start > /dev/null 2>&1
  523. comprobarError $? 901 $1
  524. fi
  525. # Intentamos habilitar en el arranque (Upstart)
  526. which update-rc.d > /dev/null 2>&1
  527. if [ $? -eq 0 ];then
  528. update-rc.d $1 enable
  529. comprobarError $? 902 $1
  530. else
  531. # Intentamos habilitar en el arranque (SystemV)
  532. which chkconfig > /dev/null 2>&1
  533. if [ $? -eq 0 ];then
  534. chkconfig $1 on
  535. comprobarError $? 902 $1
  536. else
  537. # ¿Qué mas opciones nos quedan?
  538. comprobarError 1 902 $1
  539. fi
  540. fi
  541. fi
  542. # Mejora: comprobar si el servicio está funcionando
  543. printf " OK.\n"
  544. }
  545. # Comprobación del sistema e inicialización
  546. comprobarRoot
  547. inicializarVariables
  548. OSInfo
  549. comprobarDependencias
  550. # Bienvenida
  551. mostrarBienvenida
  552. # Selección de componentes (express vs avanzada)
  553. mostrarExpress
  554. # Pre-configuración
  555. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  556. # Instalación
  557. # FALTA: whiptail --gauge -> Más bonito
  558. # Servidor Web
  559. if [ $apacheOn = true ]; then
  560. printf "Instalando Web Server Apache..."
  561. {
  562. printf "%s\n" $((100 * progreso / progresoTotal))
  563. instalarApache
  564. progreso=$((progreso + 1))
  565. } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  566. printf " OK.\n"
  567. elif [ $nginxOn = true ]; then
  568. printf "Instalando Web Server Nginx..."
  569. {
  570. printf "%s\n" $((100 * progreso / progresoTotal))
  571. instalarNginx
  572. progreso=$((progreso + 1))
  573. } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  574. printf " OK.\n"
  575. fi
  576. # Base de Datos
  577. if [ $mySQLOn = true ]; then
  578. printf "Instalando Base de Datos MySQL..."
  579. {
  580. printf "%s\n" $((100 * progreso / progresoTotal))
  581. instalarMySQL
  582. progreso=$((progreso + 1))
  583. } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  584. printf " OK.\n"
  585. elif [ $mariaDBOn = true ]; then
  586. printf "Instalando Base de Datos MariaDB..."
  587. {
  588. printf "%s\n" $((100 * progreso / progresoTotal))
  589. instalarMariaDB
  590. progreso=$((progreso + 1))
  591. } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  592. printf " OK.\n"
  593. fi
  594. # PHP
  595. if [ $phpOn = true ]; then
  596. printf "Instalando PHP-7..."
  597. {
  598. printf "%s\n" $((100 * progreso / progresoTotal))
  599. sleep 2
  600. progreso=$((progreso + 1))
  601. } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  602. printf " OK.\n"
  603. fi
  604. # SSL/TLS
  605. # Falta por implementar
  606. {
  607. printf "%s\n" $((100 * progreso / progresoTotal))
  608. sleep 2
  609. progreso=$((progreso + 1))
  610. } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  611. # MediaWiki
  612. if [ $mediaWikiOn = true ]; then
  613. printf "Instalando MediaWiki..."
  614. {
  615. printf "%s\n" $((100 * progreso / progresoTotal))
  616. sleep 2
  617. progreso=$((progreso + 1))
  618. } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  619. printf " OK.\n"
  620. fi
  621. # Moodle
  622. if [ $moodleOn = true ]; then
  623. printf "Instalando Moodle..."
  624. {
  625. printf "%s\n" $((100 * progreso / progresoTotal))
  626. sleep 2
  627. progreso=$((progreso + 1))
  628. } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  629. printf " OK.\n"
  630. fi
  631. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  632. # Por ejemplo: para cambiar la contraseña de root en mysql
  633. # Configuración
  634. # Configuración Apache
  635. # Virtual Hosts
  636. printf "Configurando Servidor Web..."
  637. {
  638. printf "%s\n" $((100 * progreso / progresoTotal))
  639. sleep 2
  640. progreso=$((progreso + 1))
  641. } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  642. printf " OK.\n"
  643. # Configuración Database
  644. # Arrancar Base de Datos, establecer contraseña y configuración segura
  645. if [ $mySQLOn = true ];then
  646. printf "Configurando Base de Datos MySQL..."
  647. {
  648. printf "%s\n" $((100 * progreso / progresoTotal))
  649. habilitarServicio mysql
  650. establecerSQLPasswd
  651. progreso=$((progreso + 1))
  652. } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  653. printf " OK.\n"
  654. fi
  655. if [ $mariaDBOn = true ];then
  656. printf "Configurando Base de Datos MAriaDB..."
  657. {
  658. printf "%s\n" $((100 * progreso / progresoTotal))
  659. habilitarServicio mariadb
  660. establecerSQLPasswd
  661. progreso=$((progreso + 1))
  662. } > >(whiptail --gauge "Configurando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  663. printf " OK.\n"
  664. fi
  665. # Configuración PHP
  666. # cgi.fix_pathinfo=0
  667. # Configurar máximo de subida de archivos
  668. printf "Configurando PHP-7..."
  669. {
  670. printf "%s\n" $((100 * progreso / progresoTotal))
  671. sleep 2
  672. progreso=$((progreso + 1))
  673. } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  674. printf " OK.\n"
  675. # Configuración MediWiki
  676. printf "Configurando MediaWiki..."
  677. {
  678. printf "%s\n" $((100 * progreso / progresoTotal))
  679. sleep 2
  680. progreso=$((progreso + 1))
  681. } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  682. printf " OK.\n"
  683. # Configuración Moodle
  684. printf "Configurando Moodle..."
  685. {
  686. printf "%s\n" $((100 * progreso / progresoTotal))
  687. sleep 2
  688. progreso=$((progreso + 1))
  689. } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  690. printf " OK.\n"
  691. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  692. printf "Arrancando Servicios..."
  693. {
  694. printf "%s\n" $((100 * progreso / progresoTotal))
  695. sleep 2
  696. progreso=$((progreso + 1))
  697. } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  698. printf " OK.\n"
  699. # Añadir reglas del cortafuegos
  700. printf "Configurando Cortafuegos..."
  701. {
  702. printf "%s\n" $((100 * progreso / progresoTotal))
  703. sleep 2
  704. progreso=$((progreso + 1))
  705. } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  706. printf " OK.\n"
  707. # Configuración SSL/TLS
  708. # Generar certificados
  709. # Configurar certificados
  710. printf "Configurando SSL/TLS..."
  711. {
  712. printf "%s\n" $((100 * progreso / progresoTotal))
  713. sleep 2
  714. progreso=$((progreso + 1))
  715. } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  716. printf " OK.\n"
  717. # Configurar actualizaciones
  718. if [ $actualizacionesOn = true ]; then
  719. printf "Configurando actualizaciones automáticas..."
  720. {
  721. printf "%s\n" $((100 * progreso / progresoTotal))
  722. sleep 2
  723. progreso=$((progreso + 1))
  724. } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  725. printf " OK.\n"
  726. fi